<?php

/* openal test */

$freq = 44000; // [Hz]
$period = 0.5; // [sec]

$half_tone_diff = pow(2, 1/12);
$tone_diff = pow(2, 1/6);
$double_tone_diff = pow(2, 1/3);

$tone_list = array(
	'C' => 440 / $double_tone_diff / $double_tone_diff / $half_tone_diff,
	'D' => 440 / $double_tone_diff / $tone_diff/ $half_tone_diff,
	'E' => 440 / $double_tone_diff / $half_tone_diff,
	'F' => 440 / $double_tone_diff,
	'G' => 440 / $tone_diff,
	'A' => 440,
	'B' => 440 * $tone_diff,
	'C2' => 440 * $tone_diff *  $half_tone_diff,
);

$time = $period* count($tone_list);

$data = '';

foreach ($tone_list as $tone) {
    $volume = 127;
    for ($i = 0 ; $i < $freq * $period ; $i++) {
        $attack_time = 0.1;
	if ($i < $freq * $attack_time) {
	    $volume = 127 * ($i / $freq /$attack_time);
	}
        $value = sin(2 * M_PI * $tone * $i / $freq) * $volume + 127;
        $data .= chr($value);
    }
}

// openal setting

$dev = openal_device_open();
$con = openal_context_create($dev);
openal_context_current($con);

$buff = openal_buffer_create();
openal_buffer_data($buff, AL_FORMAT_MONO8, $data, $freq);
$src = openal_source_create();
openal_source_set($src, AL_BUFFER, $buff);

// play sound
openal_source_play($src);
sleep($time);

// destroy

openal_context_destroy($con);
openal_device_close($dev);

echo "OK\n";
exit(0);



